class com.airtightinteractive.apps.viewers.simpleViewer.Thumb
{
   var mThumbArea;
   var mImageArea;
   var mXMLManager;
   var mIndex;
   var mThumbURL;
   var mClip_mc;
   var mBase_mc;
   var mInit_mc;
   var mLoader_mc;
   var mMask_mc;
   var mViewedIcon_mc;
   var mFrame_mc;
   var mImgLoadStatus_mc;
   var mFrameTwn;
   var mSelected;
   var mThumbLoaded;
   var mImageLoaded;
   var mPopupTween;
   var mError_mc;
   var mFrameWidth;
   static var sFrameTweenLen = 10;
   function Thumb(target, index, thumbURL)
   {
      this.mThumbArea = com.airtightinteractive.apps.viewers.simpleViewer.ThumbArea.getInstance();
      this.mImageArea = com.airtightinteractive.apps.viewers.simpleViewer.ImageArea.getInstance();
      this.mXMLManager = com.airtightinteractive.apps.viewers.simpleViewer.XMLManager.getInstance();
      this.mIndex = index;
      this.mThumbURL = thumbURL;
      var _loc2_ = target.getNextHighestDepth();
      this.mClip_mc = target.createEmptyMovieClip("clip" + _loc2_,_loc2_);
      this.mBase_mc = this.mClip_mc.createEmptyMovieClip("base",this.mClip_mc.getNextHighestDepth());
      this.mInit_mc = this.mBase_mc.attachMovie("InitialIcon","mcInit",this.mBase_mc.getNextHighestDepth());
      this.mInit_mc._x = Math.round(com.airtightinteractive.apps.viewers.simpleViewer.Options.thumbnailWidth / 2 - this.mInit_mc._width / 2);
      this.mInit_mc._y = Math.round(com.airtightinteractive.apps.viewers.simpleViewer.Options.thumbnailHeight / 2 - this.mInit_mc._height / 2);
      var _loc4_ = new Color(this.mInit_mc);
      _loc4_.setRGB(this.mXMLManager.thumbnailFrameColor);
      this.mLoader_mc = this.mBase_mc.createEmptyMovieClip("loader",this.mBase_mc.getNextHighestDepth());
      this.mMask_mc = this.mBase_mc.createEmptyMovieClip("mask",this.mBase_mc.getNextHighestDepth());
      if(com.airtightinteractive.apps.viewers.simpleViewer.Options.showThumbnailVisited)
      {
         this.mViewedIcon_mc = this.mBase_mc.attachMovie("DogEar","dogear",this.mBase_mc.getNextHighestDepth());
         var _loc3_ = new Color(this.mViewedIcon_mc);
         _loc3_.setRGB(this.mXMLManager.thumbnailFrameColor);
         this.mViewedIcon_mc._x = com.airtightinteractive.apps.viewers.simpleViewer.Options.thumbnailWidth - com.airtightinteractive.apps.viewers.simpleViewer.Options.thumbnailFrameWidth - 1 - this.mViewedIcon_mc._width;
         this.mViewedIcon_mc._y = com.airtightinteractive.apps.viewers.simpleViewer.Options.thumbnailFrameWidth + 1;
         this.mViewedIcon_mc._visible = false;
      }
      this.mFrame_mc = this.mBase_mc.createEmptyMovieClip("frame",this.mBase_mc.getNextHighestDepth());
      this.mFrame_mc._visible = false;
      if(com.airtightinteractive.apps.viewers.simpleViewer.Options.showThumbnailLoadBar)
      {
         this.mImgLoadStatus_mc = this.mBase_mc.createEmptyMovieClip("loadbar",this.mBase_mc.getNextHighestDepth());
      }
      this.mFrameTwn = new mx.transitions.Tween(this,"mFrameWidth",mx.transitions.easing.Strong.easeOut,com.airtightinteractive.apps.viewers.simpleViewer.Options.thumbnailFrameWidth,com.airtightinteractive.apps.viewers.simpleViewer.Options.thumbnailFrameWidth,com.airtightinteractive.apps.viewers.simpleViewer.Thumb.sFrameTweenLen,false);
      this.mFrameTwn.onMotionChanged = mx.utils.Delegate.create(this,this.drawFrame);
      this.mSelected = false;
      this.mThumbLoaded = false;
      this.mImageLoaded = false;
      this.enableMouseActions();
      if(this.mThumbArea.selectedThumbIndex == this.mIndex)
      {
         this.select();
      }
   }
   function loadThumb()
   {
      var _loc2_ = new MovieClipLoader();
      _loc2_.addListener(this);
      _loc2_.loadClip(this.mThumbURL,this.mLoader_mc);
   }
   function onLoadInit()
   {
      this.mThumbLoaded = true;
      this.mInit_mc._visible = false;
      if(this.mLoader_mc._width < this.mLoader_mc._height)
      {
         this.mLoader_mc._width = com.airtightinteractive.apps.viewers.simpleViewer.Options.thumbnailWidth;
         this.mLoader_mc._yscale = this.mLoader_mc._xscale;
      }
      else
      {
         this.mLoader_mc._height = com.airtightinteractive.apps.viewers.simpleViewer.Options.thumbnailHeight;
         this.mLoader_mc._xscale = this.mLoader_mc._yscale;
      }
      this.mLoader_mc._x = Math.floor((com.airtightinteractive.apps.viewers.simpleViewer.Options.thumbnailWidth - this.mLoader_mc._width) / 2);
      this.mLoader_mc._y = Math.floor((com.airtightinteractive.apps.viewers.simpleViewer.Options.thumbnailHeight - this.mLoader_mc._height) / 2);
      if(!this.mImageLoaded)
      {
         this.mLoader_mc._alpha = com.airtightinteractive.apps.viewers.simpleViewer.Options.thumbnailLoadingAlpha;
      }
      if(!this.mImageLoaded)
      {
         this.showImageProgress(0);
      }
      this.mMask_mc.beginFill(16777215,100);
      com.airtightinteractive.util.RectUtil.rectangle(this.mMask_mc,0,0,com.airtightinteractive.apps.viewers.simpleViewer.Options.thumbnailWidth,com.airtightinteractive.apps.viewers.simpleViewer.Options.thumbnailHeight);
      this.mMask_mc.endFill();
      this.mLoader_mc.setMask(this.mMask_mc);
      this.drawFrame();
      this.mFrame_mc._visible = true;
      this.mPopupTween = new com.airtightinteractive.util.TweenExtended(this.mBase_mc,["_x","_y","_xscale","_yscale","_alpha"],mx.transitions.easing.Regular.easeOut,[com.airtightinteractive.apps.viewers.simpleViewer.Options.thumbnailWidth / 2,com.airtightinteractive.apps.viewers.simpleViewer.Options.thumbnailHeight / 2,1,1,0],[0,0,100,100,100],10,false);
      this.mClip_mc._visible = true;
      this.mThumbArea.loadNextThumb(this.mIndex);
   }
   function onLoadError()
   {
      this.mInit_mc._visible = false;
      this.mImgLoadStatus_mc.clear();
      this.mError_mc = this.mBase_mc.attachMovie("ErrorIcon","error",this.mBase_mc.getNextHighestDepth());
      this.mError_mc._x = com.airtightinteractive.apps.viewers.simpleViewer.Options.thumbnailWidth / 2;
      this.mError_mc._y = com.airtightinteractive.apps.viewers.simpleViewer.Options.thumbnailHeight / 2;
      this.mError_mc._width = com.airtightinteractive.apps.viewers.simpleViewer.Options.thumbnailWidth / 2;
      this.mError_mc._height = com.airtightinteractive.apps.viewers.simpleViewer.Options.thumbnailHeight / 2;
      var _loc2_ = new Color(this.mError_mc);
      _loc2_.setRGB(this.mXMLManager.thumbnailFrameColor);
      new mx.transitions.Tween(this.mError_mc,"_alpha",null,0,100,10,false);
      this.mThumbArea.loadNextThumb(this.mIndex);
   }
   function showImageProgress(percent)
   {
      if(!this.mThumbLoaded || this.mImageLoaded)
      {
         return undefined;
      }
      this.mImgLoadStatus_mc.clear();
      this.mImgLoadStatus_mc.beginFill(this.mXMLManager.thumbnailFrameColor,100);
      var _loc2_ = com.airtightinteractive.apps.viewers.simpleViewer.Options.thumbnailFrameWidth;
      var _loc3_ = Math.round((com.airtightinteractive.apps.viewers.simpleViewer.Options.thumbnailWidth - 2 * _loc2_) * percent / 100);
      com.airtightinteractive.util.RectUtil.rectangle(this.mImgLoadStatus_mc,_loc2_,com.airtightinteractive.apps.viewers.simpleViewer.Options.thumbnailHeight - _loc2_ - com.airtightinteractive.apps.viewers.simpleViewer.Options.thumbnailLoadBarHeight,_loc3_ + _loc2_,com.airtightinteractive.apps.viewers.simpleViewer.Options.thumbnailHeight - _loc2_);
      this.mImgLoadStatus_mc.endFill();
   }
   function showImageLoadComplete()
   {
      this.mImageLoaded = true;
      this.mImgLoadStatus_mc.clear();
      new mx.transitions.Tween(this.mLoader_mc,"_alpha",null,com.airtightinteractive.apps.viewers.simpleViewer.Options.thumbnailLoadingAlpha,100,10,false);
      if(this.mSelected)
      {
         this.mViewedIcon_mc._visible = true;
      }
   }
   function enableMouseActions()
   {
      this.mClip_mc.onRelease = mx.utils.Delegate.create(this,this.onRelease);
      this.mClip_mc.onPress = mx.utils.Delegate.create(this,this.onPress);
      this.mClip_mc.onRollOver = mx.utils.Delegate.create(this,this.onRollOver);
      this.mClip_mc.onRollOut = mx.utils.Delegate.create(this,this.onRollOut);
      this.mClip_mc.onDragOut = mx.utils.Delegate.create(this,this.onDragOut);
      this.mClip_mc.useHandCursor = false;
   }
   function onRelease()
   {
      if(this.mSelected)
      {
         return undefined;
      }
      this.mBase_mc._x -= com.airtightinteractive.apps.viewers.simpleViewer.Options.thumbnailClickShift;
      this.mBase_mc._y -= com.airtightinteractive.apps.viewers.simpleViewer.Options.thumbnailClickShift;
      this.mThumbArea.selectedThumbIndex = this.mIndex;
   }
   function onPress()
   {
      if(this.mSelected)
      {
         return undefined;
      }
      this.mBase_mc._x += com.airtightinteractive.apps.viewers.simpleViewer.Options.thumbnailClickShift;
      this.mBase_mc._y += com.airtightinteractive.apps.viewers.simpleViewer.Options.thumbnailClickShift;
   }
   function onRollOver()
   {
      if(this.mSelected)
      {
         return undefined;
      }
      this.mFrameTwn.continueTo(com.airtightinteractive.apps.viewers.simpleViewer.Options.thumbnailRollOverFrameWidth,com.airtightinteractive.apps.viewers.simpleViewer.Thumb.sFrameTweenLen);
   }
   function onRollOut()
   {
      if(this.mSelected)
      {
         return undefined;
      }
      this.mFrameTwn.continueTo(com.airtightinteractive.apps.viewers.simpleViewer.Options.thumbnailFrameWidth,com.airtightinteractive.apps.viewers.simpleViewer.Thumb.sFrameTweenLen);
   }
   function onDragOut()
   {
      if(this.mSelected)
      {
         return undefined;
      }
      this.onRollOut();
      this.onRelease();
   }
   function select()
   {
      this.mSelected = true;
      this.mImageArea.showImage(this.mIndex);
      this.drawFrame();
      if(this.mImageLoaded)
      {
         this.mViewedIcon_mc._visible = true;
      }
      if(!this.mImageLoaded)
      {
         this.mImageArea.loadImageOutOfSequence(this.mIndex);
      }
   }
   function unselect()
   {
      this.mSelected = false;
      if(this.mClip_mc.hitTest(_root._xmouse,_root._ymouse))
      {
         this.drawFrame();
      }
      else
      {
         this.mFrameTwn.continueTo(com.airtightinteractive.apps.viewers.simpleViewer.Options.thumbnailFrameWidth,com.airtightinteractive.apps.viewers.simpleViewer.Thumb.sFrameTweenLen);
      }
   }
   static function get thumbWidth()
   {
      return com.airtightinteractive.apps.viewers.simpleViewer.Options.thumbnailWidth;
   }
   static function get thumbHeight()
   {
      return com.airtightinteractive.apps.viewers.simpleViewer.Options.thumbnailHeight;
   }
   static function get clickShift()
   {
      return com.airtightinteractive.apps.viewers.simpleViewer.Options.thumbnailClickShift;
   }
   static function get selectedFrameOffset()
   {
      return com.airtightinteractive.apps.viewers.simpleViewer.Options.thumbnailSelectedFrameOffset;
   }
   static function get padding()
   {
      return com.airtightinteractive.apps.viewers.simpleViewer.Options.thumbnailPadding;
   }
   function setPosn(x, y)
   {
      this.mClip_mc._x = x;
      this.mClip_mc._y = y;
   }
   function drawFrame()
   {
      this.mFrame_mc.clear();
      this.mFrame_mc.beginFill(this.mXMLManager.thumbnailFrameColor,100);
      if(this.mSelected)
      {
         com.airtightinteractive.util.RectUtil.hollowRectangle(this.mFrame_mc,- com.airtightinteractive.apps.viewers.simpleViewer.Options.thumbnailSelectedFrameOffset,- com.airtightinteractive.apps.viewers.simpleViewer.Options.thumbnailSelectedFrameOffset,com.airtightinteractive.apps.viewers.simpleViewer.Options.thumbnailWidth + com.airtightinteractive.apps.viewers.simpleViewer.Options.thumbnailSelectedFrameOffset,com.airtightinteractive.apps.viewers.simpleViewer.Options.thumbnailHeight + com.airtightinteractive.apps.viewers.simpleViewer.Options.thumbnailSelectedFrameOffset,com.airtightinteractive.apps.viewers.simpleViewer.Options.thumbnailRollOverFrameWidth);
      }
      else
      {
         com.airtightinteractive.util.RectUtil.hollowRectangle(this.mFrame_mc,0,0,com.airtightinteractive.apps.viewers.simpleViewer.Options.thumbnailWidth,com.airtightinteractive.apps.viewers.simpleViewer.Options.thumbnailHeight,this.mFrameWidth);
      }
      this.mFrame_mc.endFill();
   }
}
